/******************
swappi.js
ver. 2007-1214_1.0
(C) 2007 Wataru Kanzaki, Wings-Winds, http://wi-wi.jp/
http://home.wi-wi.jp/software/web/swappi/
******************/
/*****************
usage:

swappi and swappe must be img's class
swappa must be img's class inside <a> or <button>
swappo must be img's class and <a> or <button>'s class

----------------
class "swappi"
<img src="top.gif" class="swappi">

change the src
    "top.gif" to "top_.gif" onmouseover
    "top_.gif" to "top.gif" onmouseout

----------------
class "swappe"
<img src="top.gif" class="swappe">

change the src
    "top.gif" to "top_.gif" onclick and restore on another onclick

----------------
class "swappa"
<a href=""><img src="top.gif" class="swappa"><span>something</span></a>

change images' src in the anchor
    "top.gif" to "top_.gif" onmouseover and onfocus on the anchor
    "top_.gif" to "top.gif" onmouseout and onblur on the anchor

--------
<a href=""><img src="top.gif" class="swappa"><span>something</span><img src="bottom.gif"></a>
the src of images which className was not givven will not change.

--------
<a href=""><img src="top.gif" class="swappa"><span>something</span><img src="bottom.gif" class="swappa"></a>

all images' src in the anchor will be change
  "top.gif" to "top_.gif", "bottom.gif" to "bottom_.gif" onmouseover and onfocus on the anchor

----------------
class "swappo[number]"
<p><a href="" class="swappo1">something</a></p>
<p><img src="top.gif" class="swappo1"><img src="top.gif" class="swappo1"></p>

change images' src which the classes are the same as anchor's class

----------------
swappa and swappo will work on <button>

<button><img src="top.gif" class="swappa"></button>

*****************/
var Swappi;
if(!Swappi){
	Swappi={
		imgs:[]
		,ancs:[]
	};
}
Swappi.Swap=function(e){
	if(!e)e=window.event;
	var tar=e.target||e.srcElement||e;
	if(tar.nodeType==3)
		tar=tar.parentNode;
	if(tar.nodeName.toUpperCase()=='A'||tar.nodeName.toUpperCase()=='BUTTON'){
		for(var i=0,s,anc;anc=Swappi.ancs[i];i++){
			if(anc[0]!=tar)
				continue;
			for(var j=0,img;img=anc[2][j];j++){
				img[0].src=img[2];
			}
		}
	}else if(tar.nodeName.toUpperCase()=='IMG'){
		for(var i=0,s,img;img=Swappi.imgs[i];i++){
			if(img[0]!=tar)
				continue;
		
			s=tar.src;
			s=(img[1])?(img[2])?s.replace(/(.+)_(\.[^\/]*)$/, "$1$2"):s.replace(/(.+)(\.[^\/]*)$/, "$1_$2"):s.replace(/(.+)(\.[^\/]*)$/, "$1_$2");
			tar.src=s;
			if(img[1])
				img[2]=!img[2];
			break;
		}
	}
	return true;
};
Swappi.Swapout=function(e){
	if(!e)e=window.event;
	var tar=e.target||e.srcElement||e;
	if(tar.nodeName.toUpperCase()=='A'||tar.nodeName.toUpperCase()=='BUTTON'){
		ANCS:for(var i=0,s,anc;anc=Swappi.ancs[i];i++){
			if(anc[0]!=tar)
				continue;
			for(var j=0,on;on=anc[3][j];j++){
				if(on[1])
					break ANCS;
			}
			for(var j=0,img;img=anc[2][j];j++)
				img[0].src=img[1];
		}
	}else if(tar.nodeName.toUpperCase()=='IMG'){
		for(var i=0,s,img;img=Swappi.imgs[i];i++){
			if(img[0]!=tar)
				continue;
			if(!img[2]){
				s=tar.src;
				s=s.replace(/(.+)_(\.[^\/]*)$/, "$1$2");
				tar.src=s;
			}
			break;
		}
	}
};
Swappi.Swapin=function(e){
	if(!e)e=window.event;
	var tar=e.target||e.srcElement;
	var pa=tar.parentNode;
	while(pa){
		if(pa.nodeName.toUpperCase()=='A'||pa.nodeName.toUpperCase()=='BUTTON')
			break;
		pa=pa.parentNode;
	}
	if(!pa)
		return false;
	for(var i=0,an;an=Swappi.ancs[i];i++){
		if(an[0]!=pa)
			continue;
		for(var j=0,ch;ch=an[3][j];j++){
			if(ch[0]!=tar)
				continue;
			ch[1]=!ch[1];
			if(ch[1])
				Swappi.Swap(pa);
			else
				Swappi.Swapout(pa);
			break;
		}
		break;
	}
};
Swappi.Create=function(){
	Swappi.RemoveEvent(window, 'load', Swappi.Create);
	Swappi.imgs=[];
	Swappi.ancs=[];
	
	var doc=document.body||document.documentElement||document;
	if(!doc)
		return false;
	var imgs=document.getElementsByTagName('IMG');
	var reg=/ swapp([aiueo])([0-9]*) /;
	for(var i=0,re,cn,mode,id,img;img=imgs[i];i++){
		if(!img.src)
			continue;
		cn=' '+img.className+' ';
		re=reg.exec(cn);
		if(!re)
			continue;
		mode=RegExp.$1;
		id=RegExp.$2;
		Swappi.AddSwap[mode](img,id);
	}
	Swappi.AddSwap.o();
	return true;
};
Swappi.AddEvent=function(){
	if(!!window.addEventListener)
		return function(el, ev, func, bool){el.addEventListener(ev, func, bool||false);return true;};
	else if(!!window.attachEvent)
		return function(el, ev, func){el.attachEvent('on'+ev, func);return true;};
	else
		return function(){return false;};
}();
Swappi.RemoveEvent=function(){
	if(!!window.removeEventListener)
		return function(el, ev, func, bool){el.removeEventListener(ev, func, bool||false);return true;};
	else if(!!window.dettachEvent)
		return function(el, ev, func){el.dettachEvent('on'+ev, func);return true;};
	else
		return function(){return false;};
}();
Swappi.AddSwap={as:null};
// anchor onmouseover, onmouseout, onfocus, onblur
Swappi.AddSwap.a=function(img, id) {
	var pa=img.parentNode;
	while(pa){
		if(pa.nodeName.toUpperCase()=='A'||pa.nodeName.toUpperCase()=='BUTTON')
			break;
		pa=pa.parentNode;
	}
	if(!pa)
		return false;
	var an;
	for(var i=0;an=Swappi.ancs[i];i++){
		if(an[0]!=pa)
			continue;
		if(an[1]!='a')
			return false;
		break;
	}
	if(an){
		an[2].push([img,img.src,img.src.replace(/(.+)(\.[^\/]*)$/, "$1_$2")]);
	}else{
		var childs=[];
		var els=pa.getElementsByTagName('*');
		for(var i=0,el;el=els[i];i++){
			if(el.nodeType!=1)
				continue;
			childs.push([el,false]);
			Swappi.AddEvent(el, 'mouseover', Swappi.Swapin);
			Swappi.AddEvent(el, 'mouseout', Swappi.Swapin);
		}
		Swappi.ancs.push([pa, 'a', [[img,img.src,img.src.replace(/(.+)(\.[^\/]*)$/, "$1_$2")]], childs]);
		Swappi.AddEvent(pa, 'mouseover', Swappi.Swap);
		Swappi.AddEvent(pa, 'focus', Swappi.Swap);
		Swappi.AddEvent(pa, 'mouseout', Swappi.Swapout);
		Swappi.AddEvent(pa, 'blur', Swappi.Swapout);
	}
	return true;
};
// image onmouseover, onmouseout
Swappi.AddSwap.i=function(img, id){
	Swappi.imgs.push([img, false, false]);
	Swappi.AddEvent(img, 'mouseover', Swappi.Swap);
	Swappi.AddEvent(img, 'mouseout', Swappi.Swapout);
	return true;
};
// image onclick
Swappi.AddSwap.e=function(img,id){
	Swappi.imgs.push([img, true, false]);
	Swappi.AddEvent(img, 'click', Swappi.Swap);
};

Swappi.AddSwap.u=function(img,id){
	return true;
};

// anchor onmouseover, onmouseout, onfocus, onblur
// with ID
Swappi.AddSwap.o=function(img,id){
	if(!img)
		return Regist();
	if(!Swappi.AddSwap.as)
		Swappi.AddSwap.as=MakeAs();
	if(!id)id='swappo';
	Swappi.AddSwap.as[id][1].push(img);
	return true;
	
	function MakeAs(){
		var result={};
		var reg=/ swappo([0-9]*) /;
		var nodes=[];
		var ns=document.getElementsByTagName('A');
		for(var i=0;i<ns.length;nodes.push(ns[i++]));
		ns=document.getElementsByTagName('BUTTON');
		for(var i=0;i<ns.length;nodes.push(ns[i++]));

		for(var i=0,c,id,a;a=nodes[i];i++){
			c=' '+a.className+' ';
			if(!reg.exec(c))
				continue;
			id=RegExp.$1;
			if(!id)id='swappo';
			if(!result[id]){
				result[id]=[[a],[]];
			}else{
				result[id][0].push(a);
			}
		}
		return result;
	}//
	
	function Regist(){
		for(var i in Swappi.AddSwap.as){
			var al=Swappi.AddSwap.as[i];
			
			var imgs=[];
			for(var k=0;k<al[1].length;k++)
				imgs.push([al[1][k],al[1][k].src,al[1][k].src.replace(/(.+)(\.[^\/]*)$/, "$1_$2")]);
			for(var j=0,a,childs;a=al[0][j];j++){
				
				childs=[];
				var els=a.getElementsByTagName('*');
				for(var i=0,el;el=els[i];i++){
					if(el.nodeType!=1)
						continue;
					childs.push([el,false]);
					Swappi.AddEvent(el, 'mouseover', Swappi.Swapin);
					Swappi.AddEvent(el, 'mouseout', Swappi.Swapin);
				}
				
				Swappi.ancs.push([a, 'o', imgs, childs]);
				Swappi.AddEvent(a, 'mouseover', Swappi.Swap);
				Swappi.AddEvent(a, 'focus', Swappi.Swap);
				Swappi.AddEvent(a, 'mouseout', Swappi.Swapout);
				Swappi.AddEvent(a, 'blur', Swappi.Swapout);
			}
		}
		Swappi.AddSwap.as=null;
		return true;
	}//
};

Swappi.AddEvent(window, 'load', Swappi.Create);
